# std::__debug::list< _Tp, _Allocator > Class Template Reference

Class std::list with safety/checking/debug instrumentation. More...

Inheritance diagram for std::__debug::list< _Tp, _Allocator >:
[legend]

List of all members.

## Public Types

- typedef _Allocator allocator_type
- typedef
  __gnu_debug::_Safe_iterator
  < typename
  _Base::const_iterator, list > const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef std::reverse_iterator
  < const_iterator > const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef
  __gnu_debug::_Safe_iterator
  < typename _Base::iterator,
  list > iterator
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef std::reverse_iterator
  < iterator > reverse_iterator
- typedef _Base::size_type size_type
- typedef _Tp value_type

## Public Member Functions

- list (const _Allocator &__a=_Allocator())
- list (size_type __n, const _Tp &__value=_Tp(), const _Allocator &__a=_Allocator())
- list (const list &__x)
- list (const _Base &__x)
- template<class _InputIterator > list (_InputIterator __first, _InputIterator __last, const _Allocator &__a=_Allocator())
- list (list &&__x)
- list (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
- _Base & _M_base ()
- const _Base & _M_base () const
- void _M_invalidate_all () const
- void _M_invalidate_if (_Predicate __pred)
- void _M_transfer_iter (const _Safe_iterator< _Iterator, list< _Tp, _Allocator > > &__x)
- void assign (initializer_list< value_type > __l)
- template<class _InputIterator > void assign (_InputIterator __first, _InputIterator __last)
- void assign (size_type __n, const _Tp &__t)
- const_reference back () const
- reference back ()
- const_iterator begin () const
- iterator begin ()
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- const_reverse_iterator crbegin () const
- const_reverse_iterator crend () const
- template<typename... _Args> iterator emplace (iterator __position, _Args &&...__args)
- iterator end ()
- const_iterator end () const
- iterator erase (iterator __position, iterator __last)
- iterator erase (iterator __position)
- reference front ()
- const_reference front () const
- template<class _InputIterator > void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- iterator insert (iterator __position, const _Tp &__x)
- iterator insert (iterator __position, _Tp &&__x)
- void insert (iterator __p, initializer_list< value_type > __l)
- void insert (iterator __position, size_type __n, const _Tp &__x)
- void merge (list &__x)
- void merge (list &&__x)
- template<class _Compare > void merge (list &&__x, _Compare __comp)
- template<typename _Compare > void merge (list &__x, _Compare __comp)
- list & operator= (const list &__x)
- list & operator= (list &&__x)
- list & operator= (initializer_list< value_type > __l)
- void pop_back ()
- void pop_front ()
- reverse_iterator rbegin ()
- const_reverse_iterator rbegin () const
- void remove (const _Tp &__value)
- template<class _Predicate > void remove_if (_Predicate __pred)
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void resize (size_type __sz, _Tp __c=_Tp())
- void sort ()
- template<typename _StrictWeakOrdering > void sort (_StrictWeakOrdering __pred)
- void splice (iterator __position, list &&__x)
- void splice (iterator __position, list &__x, iterator __i)
- void splice (iterator __position, list &&__x, iterator __first, iterator __last)
- void splice (iterator __position, list &__x, iterator __first, iterator __last)
- void splice (iterator __position, list &__x)
- void splice (iterator __position, list &&__x, iterator __i)
- void swap (list &__x)
- template<class _BinaryPredicate > void unique (_BinaryPredicate __binary_pred)
- void unique ()

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex () throw ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Detailed Description

### template<typename _Tp, typename _Allocator = std::allocator<_Tp>>
class std::__debug::list< _Tp, _Allocator >

Class std::list with safety/checking/debug instrumentation.

Definition at line 43 of file debug/list.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | throw ()`[protected, inherited]`

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 215 of file safe_base.h.

void __gnu_debug::_Safe_sequence< list< _Tp, _Allocator > >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

void __gnu_debug::_Safe_sequence< list< _Tp, _Allocator > >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, list< _Tp, _Allocator > > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators `[inherited]`

The list of constant iterators that reference this container.

Definition at line 166 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators `[inherited]`

The list of mutable iterators that reference this container.

Definition at line 163 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version `[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 169 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/list